## AtkObject AtkObject — The base object class for the Accessibility Toolkit API. |

## Functions

AtkRole | atk_role_register ()
gboolean | (*AtkFunction) ()
void | (*AtkPropertyChangeHandler) ()
AtkObject * | atk_implementor_ref_accessible ()
const gchar * | atk_object_get_name ()
const gchar * | atk_object_get_description ()
AtkObject * | atk_object_get_parent ()
AtkObject * | atk_object_peek_parent ()
gint | atk_object_get_n_accessible_children ()
AtkObject * | atk_object_ref_accessible_child ()
AtkRelationSet * | atk_object_ref_relation_set ()
AtkLayer | atk_object_get_layer ()
gint | atk_object_get_mdi_zorder ()
AtkRole | atk_object_get_role ()
AtkStateSet * | atk_object_ref_state_set ()
gint | atk_object_get_index_in_parent ()
void | atk_object_set_name ()
void | atk_object_set_description ()
void | atk_object_set_parent ()
void | atk_object_set_role ()
guint | atk_object_connect_property_change_handler ()
void | atk_object_remove_property_change_handler ()
void | atk_object_notify_state_change ()
void | atk_object_initialize ()
gboolean | atk_object_add_relationship ()
gboolean | atk_object_remove_relationship ()
AtkAttributeSet * | atk_object_get_attributes ()
const gchar * | atk_object_get_object_locale ()
const gchar * | atk_object_get_accessible_id ()
void | atk_object_set_accessible_id ()
const gchar * | atk_role_get_name ()
const gchar * | atk_role_get_localized_name ()
AtkRole | atk_role_for_name ()

## Properties

gint | accessible-component-layer | Read
gint | accessible-component-mdi-zorder | Read
gchar * | accessible-description | Read / Write
gint | accessible-hypertext-nlinks | Read
gchar * | accessible-name | Read / Write
AtkObject * | accessible-parent | Read / Write
AtkRole | accessible-role | Read / Write
gchar * | accessible-table-caption | Read / Write
AtkObject * | accessible-table-caption-object | Read / Write
gchar * | accessible-table-column-description | Read / Write
AtkObject * | accessible-table-column-header | Read / Write
gchar * | accessible-table-row-description | Read / Write
AtkObject * | accessible-table-row-header | Read / Write
AtkObject * | accessible-table-summary | Read / Write
gdouble | accessible-value | Read / Write

## Signals

void | active-descendant-changed | Has Details
void | children-changed | Has Details
void | focus-event | Run Last
void | property-change | Has Details
void | state-change | Has Details
void | visible-data-changed | Run Last

## Types and Values

struct | AtkObject
enum | AtkRole
enum | AtkLayer
| AtkImplementor
struct | AtkAttribute
typedef | AtkAttributeSet
| AtkPropertyValues

## Object Hierarchy

        GEnum
        ├── AtkLayer
        ╰── AtkRole
        GInterface
        ╰── AtkImplementorIface
        GObject
        ╰── AtkObject
            ├── AtkGObjectAccessible
            ├── AtkNoOpObject
            ├── AtkPlug
            ╰── AtkSocket

## Known Derived Interfaces

AtkObject is required by AtkTableCell and AtkWindow.

## Includes

    #include <atk/atk.h>

## Description

This class is the primary class for accessibility support via the Accessibility ToolKit (ATK). Objects which are instances of AtkObject (or instances of AtkObject-derived types) are queried for properties which relate basic (and generic) properties of a UI component such as name and description. Instances of AtkObject may also be queried as to whether they implement other ATK interfaces (e.g. AtkAction, AtkComponent, etc.), as appropriate to the role which a given UI component plays in a user interface.

All UI components in an application which provide useful information or services to the user must provide corresponding AtkObject instances on request (in GTK+, for instance, usually on a call to ``gtk_widget_get_accessible()``), either via ATK support built into the toolkit for the widget class or ancestor class, or in the case of custom widgets, if the inherited AtkObject implementation is insufficient, via instances of a new AtkObject subclass.

See also: AtkObjectFactory, AtkRegistry. (GTK+ users see also GtkAccessible).

## Functions

### atk_role_register ()

    AtkRole
    atk_role_register (const gchar *name);

`atk_role_register` is deprecated and should not be used in newly-written code.

Since 2.12. If your application/toolkit doesn't find a suitable role for a specific object defined at AtkRole, please submit a bug in order to add a new role to the specification.

Registers the role specified by `name` . `name` must be a meaningful name. So it should not be empty, or consisting on whitespaces.

#### Parameters

name | a character string describing the new role. |

#### Returns

an AtkRole for the new role if added properly. ATK_ROLE_INVALID in case of error.

### AtkFunction ()

    gboolean
    (*AtkFunction) (gpointer user_data);

An AtkFunction is a function definition used for padding which has been added to class and interface structures to allow for expansion in the future.

#### Parameters

user_data | custom data defined by the user |

#### Returns

not used

### AtkPropertyChangeHandler ()

    void
    (*AtkPropertyChangeHandler) (AtkObject *obj,
                                 AtkPropertyValues *vals);

`AtkPropertyChangeHandler` is deprecated and should not be used in newly-written code.

Since 2.12.

An AtkPropertyChangeHandler is a function which is executed when an AtkObject's property changes value. It is specified in a call to `atk_object_connect_property_change_handler()`.

#### Parameters

obj | atkobject which property changes |
vals | values changed |

### atk_implementor_ref_accessible ()

    AtkObject *
    atk_implementor_ref_accessible (AtkImplementor *implementor);

Gets a reference to an object's AtkObject implementation, if the object implements AtkObjectIface

#### Parameters

implementor | The GObject instance which should implement AtkImplementorIface if a non-null return value is required. |

#### Returns

a reference to an object's AtkObject implementation.

[transfer full]

### atk_object_get_name ()

    const gchar *
    atk_object_get_name (AtkObject *accessible);

Gets the accessible name of the accessible.

#### Parameters

accessible | an AtkObject |

#### Returns

a character string representing the accessible name of the object.

### atk_object_get_description ()

    const gchar *
    atk_object_get_description (AtkObject *accessible);

Gets the accessible description of the accessible.

#### Parameters

accessible | an AtkObject |

#### Returns

a character string representing the accessible description of the accessible.

### atk_object_get_parent ()

    AtkObject *
    atk_object_get_parent (AtkObject *accessible);

Gets the accessible parent of the accessible. By default this is the one assigned with `atk_object_set_parent()`, but it is assumed that ATK implementors have ways to get the parent of the object without the need of assigning it manually with `atk_object_set_parent()`, and will return it with this method.

If you are only interested on the parent assigned with `atk_object_set_parent()`, use `atk_object_peek_parent()`.

#### Parameters

accessible | an AtkObject |

#### Returns

an AtkObject representing the accessible parent of the accessible.

[transfer none]

### atk_object_peek_parent ()

    AtkObject *
    atk_object_peek_parent (AtkObject *accessible);

Gets the accessible parent of the accessible, if it has been manually assigned with atk_object_set_parent. Otherwise, this function returns `NULL`.

This method is intended as an utility for ATK implementors, and not to be exposed to accessible tools. See `atk_object_get_parent()` for further reference.

#### Parameters

accessible | an AtkObject |

#### Returns

an AtkObject representing the accessible parent of the accessible if assigned.

[transfer none]

### atk_object_get_n_accessible_children ()

    gint
    atk_object_get_n_accessible_children (AtkObject *accessible);

Gets the number of accessible children of the accessible.

#### Parameters

accessible | an AtkObject |

#### Returns

an integer representing the number of accessible children of the accessible.

### atk_object_ref_accessible_child ()

    AtkObject *
    atk_object_ref_accessible_child (AtkObject *accessible,
                                     gint i);

Gets a reference to the specified accessible child of the object. The accessible children are 0-based so the first accessible child is at index 0, the second at index 1 and so on.

#### Parameters

accessible | an AtkObject |
i | a gint representing the position of the child, starting from 0 |

#### Returns

an AtkObject representing the specified accessible child of the accessible.

[transfer full]

### atk_object_ref_relation_set ()

    AtkRelationSet *
    atk_object_ref_relation_set (AtkObject *accessible);

Gets the AtkRelationSet associated with the object.

#### Parameters

accessible | an AtkObject |

#### Returns

an AtkRelationSet representing the relation set of the object.

[transfer full]

### atk_object_get_layer ()

    AtkLayer
    atk_object_get_layer (AtkObject *accessible);

`atk_object_get_layer` is deprecated and should not be used in newly-written code.

Use atk_component_get_layer instead.

Gets the layer of the accessible.

#### Parameters

accessible | an AtkObject |

#### Returns

an AtkLayer which is the layer of the accessible

### atk_object_get_mdi_zorder ()

    gint
    atk_object_get_mdi_zorder (AtkObject *accessible);

`atk_object_get_mdi_zorder` is deprecated and should not be used in newly-written code.

Use atk_component_get_mdi_zorder instead.

Gets the zorder of the accessible. The value G_MININT will be returned if the layer of the accessible is not ATK_LAYER_MDI.

#### Parameters

accessible | an AtkObject |

#### Returns

a gint which is the zorder of the accessible, i.e. the depth at which the component is shown in relation to other components in the same container.

### atk_object_get_role ()

    AtkRole
    atk_object_get_role (AtkObject *accessible);

Gets the role of the accessible.

#### Parameters

accessible | an AtkObject |

#### Returns

an AtkRole which is the role of the accessible

### atk_object_ref_state_set ()

    AtkStateSet *
    atk_object_ref_state_set (AtkObject *accessible);

Gets a reference to the state set of the accessible; the caller must unreference it when it is no longer needed.

#### Parameters

accessible | an AtkObject |

#### Returns

a reference to an AtkStateSet which is the state set of the accessible.

[transfer full]

### atk_object_get_index_in_parent ()

    gint
    atk_object_get_index_in_parent (AtkObject *accessible);

Gets the 0-based index of this accessible in its parent; returns -1 if the accessible does not have an accessible parent.

#### Parameters

accessible | an AtkObject |

#### Returns

an integer which is the index of the accessible in its parent

### atk_object_set_name ()

    void
    atk_object_set_name (AtkObject *accessible,
                         const gchar *name);

Sets the accessible name of the accessible. You can't set the name to NULL. This is reserved for the initial value. In this aspect NULL is similar to ATK_ROLE_UNKNOWN. If you want to set the name to a empty value you can use "".

#### Parameters

accessible | an AtkObject |
name | a character string to be set as the accessible name |

### atk_object_set_description ()

    void
    atk_object_set_description (AtkObject *accessible,
                                const gchar *description);

Sets the accessible description of the accessible. You can't set the description to NULL. This is reserved for the initial value. In this aspect NULL is similar to ATK_ROLE_UNKNOWN. If you want to set the name to a empty value you can use "".

#### Parameters

accessible | an AtkObject |
description | a character string to be set as the accessible description |

### atk_object_set_parent ()

    void
    atk_object_set_parent (AtkObject *accessible,
                           AtkObject *parent);

Sets the accessible parent of the accessible. `parent` can be NULL.

#### Parameters

accessible | an AtkObject |
parent | an AtkObject to be set as the accessible parent |

### atk_object_set_role ()

    void
    atk_object_set_role (AtkObject *accessible,
                         AtkRole role);

Sets the role of the accessible.

#### Parameters

accessible | an AtkObject |
role | an AtkRole to be set as the role |

### atk_object_connect_property_change_handler ()

    guint
    atk_object_connect_property_change_handler
                                   (AtkObject *accessible,
                                    AtkPropertyChangeHandler *handler);

`atk_object_connect_property_change_handler` has been deprecated since version 2.12 and should not be used in newly-written code.

Connect directly to “property-change” or the relevant “notify” signal for each desired property.

Calls `handler` on property changes.

[skip]

#### Parameters

accessible | an AtkObject |
handler | a function to be called when a property changes its value |

#### Returns

a guint which is the handler id used in `atk_object_remove_property_change_handler()`

### atk_object_remove_property_change_handler ()

    void
    atk_object_remove_property_change_handler
                                   (AtkObject *accessible,
                                    guint handler_id);

`atk_object_remove_property_change_handler` has been deprecated since version 2.12 and should not be used in newly-written code.

See `atk_object_connect_property_change_handler()`

Removes a property change handler.

#### Parameters

accessible | an AtkObject |
handler_id | a guint which identifies the handler to be removed. |

### atk_object_notify_state_change ()

    void
    atk_object_notify_state_change (AtkObject *accessible,
                                    AtkState state,
                                    gboolean value);

Emits a state-change signal for the specified state.

Note that as a general rule when the state of an existing object changes, emitting a notification is expected.

#### Parameters

accessible | an AtkObject |
state | an AtkState whose state is changed |
value | a gboolean which indicates whether the state is being set on or off |

### atk_object_initialize ()

    void
    atk_object_initialize (AtkObject *accessible,
                           gpointer data);

This function is called when implementing subclasses of AtkObject. It does initialization required for the new object. It is intended that this function should called only in the ..._new() functions used to create an instance of a subclass of AtkObject

#### Parameters

accessible | a AtkObject |
data | a gpointer which identifies the object for which the AtkObject was created. |

### atk_object_add_relationship ()

    gboolean
    atk_object_add_relationship (AtkObject *object,
                                 AtkRelationType relationship,
                                 AtkObject *target);

Adds a relationship of the specified type with the specified target.

#### Parameters

object | The AtkObject to which an AtkRelation is to be added. |
relationship | The AtkRelationType of the relation |
target | The AtkObject which is to be the target of the relation. |

#### Returns

TRUE if the relationship is added.

### atk_object_remove_relationship ()

    gboolean
    atk_object_remove_relationship (AtkObject *object,
                                    AtkRelationType relationship,
                                    AtkObject *target);

Removes a relationship of the specified type with the specified target.

#### Parameters

object | The AtkObject from which an AtkRelation is to be removed. |
relationship | The AtkRelationType of the relation |
target | The AtkObject which is the target of the relation to be removed. |

#### Returns

TRUE if the relationship is removed.

### atk_object_get_attributes ()

    AtkAttributeSet *
    atk_object_get_attributes (AtkObject *accessible);

Get a list of properties applied to this object as a whole, as an AtkAttributeSet consisting of name-value pairs. As such these attributes may be considered weakly-typed properties or annotations, as distinct from strongly-typed object data available via other get/set methods. Not all objects have explicit "name-value pair" AtkAttributeSet properties.

#### Parameters

accessible | An AtkObject. |

#### Returns

an AtkAttributeSet consisting of all explicit properties/annotations applied to the object, or an empty set if the object has no name-value pair attributes assigned to it. This atkattributeset should be freed by a call to `atk_attribute_set_free()`.

[transfer full]

Since: 1.12

### atk_object_get_object_locale ()

    const gchar *
    atk_object_get_object_locale (AtkObject *accessible);

Gets a UTF-8 string indicating the POSIX-style LC_MESSAGES locale of `accessible` .

#### Parameters

accessible | an AtkObject |

#### Returns

a UTF-8 string indicating the POSIX-style LC_MESSAGES locale of `accessible` .

Since: 2.8

### atk_object_get_accessible_id ()

    const gchar *
    atk_object_get_accessible_id (AtkObject *accessible);

Gets the accessible id of the accessible.

#### Parameters

accessible | an AtkObject |

#### Returns

a character string representing the accessible id of the object, or NULL if no such string was set.

Since: 2.34

### atk_object_set_accessible_id ()

    void
    atk_object_set_accessible_id (AtkObject *accessible,
                                  const gchar *name);

Sets the accessible ID of the accessible. This is not meant to be presented to the user, but to be an ID which is stable over application development. Typically, this is the gtkbuilder ID. Such an ID will be available for instance to identify a given well-known accessible object for tailored screen reading, or for automatic regression testing.

#### Parameters

accessible | an AtkObject |
name | a character string to be set as the accessible id |

Since: 2.34

### atk_role_get_name ()

    const gchar *
    atk_role_get_name (AtkRole role);

Gets the description string describing the AtkRole `role` .

#### Parameters

role | The AtkRole whose name is required |

#### Returns

the string describing the AtkRole

### atk_role_get_localized_name ()

    const gchar *
    atk_role_get_localized_name (AtkRole role);

Gets the localized description string describing the AtkRole `role` .

#### Parameters

role | The AtkRole whose localized name is required |

#### Returns

the localized string describing the AtkRole

### atk_role_for_name ()

    AtkRole
    atk_role_for_name (const gchar *name);

Get the AtkRole type corresponding to a rolew name.

#### Parameters

name | a string which is the (non-localized) name of an ATK role. |

#### Returns

the AtkRole enumerated type corresponding to the specified name, or ATK_ROLE_INVALID if no matching role is found.

## Types and Values

### struct AtkObject

    struct AtkObject;

### enum AtkRole

Describes the role of an object

These are the built-in enumerated roles that UI components can have in ATK. Other roles may be added at runtime, so an AtkRole >= `ATK_ROLE_LAST_DEFINED` is not necessarily an error.

#### Members

ATK_ROLE_INVALID | Invalid role |
ATK_ROLE_ACCEL_LABEL | A label which represents an accelerator |
ATK_ROLE_ALERT | An object which is an alert to the user. Assistive Technologies typically respond to ATK_ROLE_ALERT by reading the entire onscreen contents of containers advertising this role. Should be used for warning dialogs, etc. |
ATK_ROLE_ANIMATION | An object which is an animated image |
ATK_ROLE_ARROW | An arrow in one of the four cardinal directions |
ATK_ROLE_CALENDAR | An object that displays a calendar and allows the user to select a date |
ATK_ROLE_CANVAS | An object that can be drawn into and is used to trap events |
ATK_ROLE_CHECK_BOX | A choice that can be checked or unchecked and provides a separate indicator for the current state |
ATK_ROLE_CHECK_MENU_ITEM | A menu item with a check box |
ATK_ROLE_COLOR_CHOOSER | A specialized dialog that lets the user choose a color |
ATK_ROLE_COLUMN_HEADER | The header for a column of data |
ATK_ROLE_COMBO_BOX | A collapsible list of choices the user can select from |
ATK_ROLE_DATE_EDITOR | An object whose purpose is to allow a user to edit a date |
ATK_ROLE_DESKTOP_ICON | An inconifed internal frame within a DESKTOP_PANE |
ATK_ROLE_DESKTOP_FRAME | A pane that supports internal frames and iconified versions of those internal frames |
ATK_ROLE_DIAL | An object whose purpose is to allow a user to set a value |
ATK_ROLE_DIALOG | A top level window with title bar and a border |
ATK_ROLE_DIRECTORY_PANE | A pane that allows the user to navigate through and select the contents of a directory |
ATK_ROLE_DRAWING_AREA | An object used for drawing custom user interface elements |
ATK_ROLE_FILE_CHOOSER | A specialized dialog that lets the user choose a file |
ATK_ROLE_FILLER | A object that fills up space in a user interface |
ATK_ROLE_FONT_CHOOSER | A specialized dialog that lets the user choose a font |
ATK_ROLE_FRAME | A top level window with a title bar, border, menubar, etc. |
ATK_ROLE_GLASS_PANE | A pane that is guaranteed to be painted on top of all panes beneath it |
ATK_ROLE_HTML_CONTAINER | A document container for HTML, whose children represent the document content |
ATK_ROLE_ICON | A small fixed size picture, typically used to decorate components |
ATK_ROLE_IMAGE | An object whose primary purpose is to display an image |
ATK_ROLE_INTERNAL_FRAME | A frame-like object that is clipped by a desktop pane |
ATK_ROLE_LABEL | An object used to present an icon or short string in an interface |
ATK_ROLE_LAYERED_PANE | A specialized pane that allows its children to be drawn in layers, providing a form of stacking order |
ATK_ROLE_LIST | An object that presents a list of objects to the user and allows the user to select one or more of them |
ATK_ROLE_LIST_ITEM | An object that represents an element of a list |
ATK_ROLE_MENU | An object usually found inside a menu bar that contains a list of actions the user can choose from |
ATK_ROLE_MENU_BAR | An object usually drawn at the top of the primary dialog box of an application that contains a list of menus the user can choose from |
ATK_ROLE_MENU_ITEM | An object usually contained in a menu that presents an action the user can choose |
ATK_ROLE_OPTION_PANE | A specialized pane whose primary use is inside a DIALOG |
ATK_ROLE_PAGE_TAB | An object that is a child of a page tab list |
ATK_ROLE_PAGE_TAB_LIST | An object that presents a series of panels (or page tabs), one at a time, through some mechanism provided by the object |
ATK_ROLE_PANEL | A generic container that is often used to group objects |
ATK_ROLE_PASSWORD_TEXT | A text object uses for passwords, or other places where the text content is not shown visibly to the user |
ATK_ROLE_POPUP_MENU | A temporary window that is usually used to offer the user a list of choices, and then hides when the user selects one of those choices |
ATK_ROLE_PROGRESS_BAR | An object used to indicate how much of a task has been completed |
ATK_ROLE_PUSH_BUTTON | An object the user can manipulate to tell the application to do something |
ATK_ROLE_RADIO_BUTTON | A specialized check box that will cause other radio buttons in the same group to become unchecked when this one is checked |
ATK_ROLE_RADIO_MENU_ITEM | A check menu item which belongs to a group. At each instant exactly one of the radio menu items from a group is selected |
ATK_ROLE_ROOT_PANE | A specialized pane that has a glass pane and a layered pane as its children |
ATK_ROLE_ROW_HEADER | The header for a row of data |
ATK_ROLE_SCROLL_BAR | An object usually used to allow a user to incrementally view a large amount of data. |
ATK_ROLE_SCROLL_PANE | An object that allows a user to incrementally view a large amount of information |
ATK_ROLE_SEPARATOR | An object usually contained in a menu to provide a visible and logical separation of the contents in a menu |
ATK_ROLE_SLIDER | An object that allows the user to select from a bounded range |
ATK_ROLE_SPLIT_PANE | A specialized panel that presents two other panels at the same time |
ATK_ROLE_SPIN_BUTTON | An object used to get an integer or floating point number from the user |
ATK_ROLE_STATUSBAR | An object which reports messages of minor importance to the user |
ATK_ROLE_TABLE | An object used to represent information in terms of rows and columns |
ATK_ROLE_TABLE_CELL | A cell in a table |
ATK_ROLE_TABLE_COLUMN_HEADER | The header for a column of a table |
ATK_ROLE_TABLE_ROW_HEADER | The header for a row of a table |
ATK_ROLE_TEAR_OFF_MENU_ITEM | A menu item used to tear off and reattach its menu |
ATK_ROLE_TERMINAL | An object that represents an accessible terminal. (Since: 0.6) |
ATK_ROLE_TEXT | An interactive widget that supports multiple lines of text and optionally accepts user input, but whose purpose is not to solicit user input. Thus ATK_ROLE_TEXT is appropriate for the text view in a plain text editor but inappropriate for an input field in a dialog box or web form. For widgets whose purpose is to solicit input from the user, see ATK_ROLE_ENTRY and ATK_ROLE_PASSWORD_TEXT. For generic objects which display a brief amount of textual information, see ATK_ROLE_STATIC. |
ATK_ROLE_TOGGLE_BUTTON | A specialized push button that can be checked or unchecked, but does not provide a separate indicator for the current state |
ATK_ROLE_TOOL_BAR | A bar or palette usually composed of push buttons or toggle buttons |
ATK_ROLE_TOOL_TIP | An object that provides information about another object |
ATK_ROLE_TREE | An object used to represent hierarchical information to the user |
ATK_ROLE_TREE_TABLE | An object capable of expanding and collapsing rows as well as showing multiple columns of data. (Since: 0.7) |
ATK_ROLE_UNKNOWN | The object contains some Accessible information, but its role is not known |
ATK_ROLE_VIEWPORT | An object usually used in a scroll pane |
ATK_ROLE_WINDOW | A top level window with no title or border. |
ATK_ROLE_HEADER | An object that serves as a document header. (Since: 1.1.1) |
ATK_ROLE_FOOTER | An object that serves as a document footer. (Since: 1.1.1) |
ATK_ROLE_PARAGRAPH | An object which is contains a paragraph of text content. (Since: 1.1.1) |
ATK_ROLE_RULER | An object which describes margins and tab stops, etc. for text objects which it controls (should have CONTROLLER_FOR relation to such). (Since: 1.1.1) |
ATK_ROLE_APPLICATION | The object is an application object, which may contain `ATK_ROLE_FRAME` objects or other types of accessibles. The root accessible of any application's ATK hierarchy should have ATK_ROLE_APPLICATION. (Since: 1.1.4) |
ATK_ROLE_AUTOCOMPLETE | The object is a dialog or list containing items for insertion into an entry widget, for instance a list of words for completion of a text entry. (Since: 1.3) |
ATK_ROLE_EDITBAR | The object is an editable text object in a toolbar. (Since: 1.5) |
ATK_ROLE_EMBEDDED | The object is an embedded container within a document or panel. This role is a grouping "hint" indicating that the contained objects share a context. (Since: 1.7.2) |
ATK_ROLE_ENTRY | The object is a component whose textual content may be entered or modified by the user, provided `ATK_STATE_EDITABLE` is present. (Since: 1.11) |
ATK_ROLE_CHART | The object is a graphical depiction of quantitative data. It may contain multiple subelements whose attributes and/or description may be queried to obtain both the quantitative data and information about how the data is being presented. The LABELLED_BY relation is particularly important in interpreting objects of this type, as is the accessible-description property. (Since: 1.11) |
ATK_ROLE_CAPTION | The object contains descriptive information, usually textual, about another user interface element such as a table, chart, or image. (Since: 1.11) |
ATK_ROLE_DOCUMENT_FRAME | The object is a visual frame or container which contains a view of document content. Document frames may occur within another Document instance, in which case the second document may be said to be embedded in the containing instance. HTML frames are often ROLE_DOCUMENT_FRAME. Either this object, or a singleton descendant, should implement the Document interface. (Since: 1.11) |
ATK_ROLE_HEADING | The object serves as a heading for content which follows it in a document. The 'heading level' of the heading, if availabe, may be obtained by querying the object's attributes. |
ATK_ROLE_PAGE | The object is a containing instance which encapsulates a page of information. `ATK_ROLE_PAGE` is used in documents and content which support a paginated navigation model. (Since: 1.11) |
ATK_ROLE_SECTION | The object is a containing instance of document content which constitutes a particular 'logical' section of the document. The type of content within a section, and the nature of the section division itself, may be obtained by querying the object's attributes. Sections may be nested. (Since: 1.11) |
ATK_ROLE_REDUNDANT_OBJECT | The object is redundant with another object in the hierarchy, and is exposed for purely technical reasons. Objects of this role should normally be ignored by clients. (Since: 1.11) |
ATK_ROLE_FORM | The object is a container for form controls, for instance as part of a web form or user-input form within a document. This role is primarily a tag/convenience for clients when navigating complex documents, it is not expected that ordinary GUI containers will always have ATK_ROLE_FORM. (Since: 1.12.0) |
ATK_ROLE_LINK | The object is a hypertext anchor, i.e. a "link" in a hypertext document. Such objects are distinct from 'inline' content which may also use the Hypertext/Hyperlink interfaces to indicate the range/location within a text object where an inline or embedded object lies. (Since: 1.12.1) |
ATK_ROLE_INPUT_METHOD_WINDOW | The object is a window or similar viewport which is used to allow composition or input of a 'complex character', in other words it is an "input method window." (Since: 1.12.1) |
ATK_ROLE_TABLE_ROW | A row in a table. (Since: 2.1.0) |
ATK_ROLE_TREE_ITEM | An object that represents an element of a tree. (Since: 2.1.0) |
ATK_ROLE_DOCUMENT_SPREADSHEET | A document frame which contains a spreadsheet. (Since: 2.1.0) |
ATK_ROLE_DOCUMENT_PRESENTATION | A document frame which contains a presentation or slide content. (Since: 2.1.0) |
ATK_ROLE_DOCUMENT_TEXT | A document frame which contains textual content, such as found in a word processing application. (Since: 2.1.0) |
ATK_ROLE_DOCUMENT_WEB | A document frame which contains HTML or other markup suitable for display in a web browser. (Since: 2.1.0) |
ATK_ROLE_DOCUMENT_EMAIL | A document frame which contains email content to be displayed or composed either in plain text or HTML. (Since: 2.1.0) |
ATK_ROLE_COMMENT | An object found within a document and designed to present a comment, note, or other annotation. In some cases, this object might not be visible until activated. (Since: 2.1.0) |
ATK_ROLE_LIST_BOX | A non-collapsible list of choices the user can select from. (Since: 2.1.0) |
ATK_ROLE_GROUPING | A group of related widgets. This group typically has a label. (Since: 2.1.0) |
ATK_ROLE_IMAGE_MAP | An image map object. Usually a graphic with multiple hotspots, where each hotspot can be activated resulting in the loading of another document or section of a document. (Since: 2.1.0) |
ATK_ROLE_NOTIFICATION | A transitory object designed to present a message to the user, typically at the desktop level rather than inside a particular application. (Since: 2.1.0) |
ATK_ROLE_INFO_BAR | An object designed to present a message to the user within an existing window. (Since: 2.1.0) |
ATK_ROLE_LEVEL_BAR | A bar that serves as a level indicator to, for instance, show the strength of a password or the state of a battery. (Since: 2.7.3) |
ATK_ROLE_TITLE_BAR | A bar that serves as the title of a window or a dialog. (Since: 2.12) |
ATK_ROLE_BLOCK_QUOTE | An object which contains a text section that is quoted from another source. (Since: 2.12) |
ATK_ROLE_AUDIO | An object which represents an audio element. (Since: 2.12) |
ATK_ROLE_VIDEO | An object which represents a video element. (Since: 2.12) |
ATK_ROLE_DEFINITION | A definition of a term or concept. (Since: 2.12) |
ATK_ROLE_ARTICLE | A section of a page that consists of a composition that forms an independent part of a document, page, or site. Examples: A blog entry, a news story, a forum post. (Since: 2.12) |
ATK_ROLE_LANDMARK | A region of a web page intended as a navigational landmark. This is designed to allow Assistive Technologies to provide quick navigation among key regions within a document. (Since: 2.12) |
ATK_ROLE_LOG | A text widget or container holding log content, such as chat history and error logs. In this role there is a relationship between the arrival of new items in the log and the reading order. The log contains a meaningful sequence and new information is added only to the end of the log, not at arbitrary points. (Since: 2.12) |
ATK_ROLE_MARQUEE | A container where non-essential information changes frequently. Common usages of marquee include stock tickers and ad banners. The primary difference between a marquee and a log is that logs usually have a meaningful order or sequence of important content changes. (Since: 2.12) |
ATK_ROLE_MATH | A text widget or container that holds a mathematical expression. (Since: 2.12) |
ATK_ROLE_RATING | A widget whose purpose is to display a rating, such as the number of stars associated with a song in a media player. Objects of this role should also implement AtkValue. (Since: 2.12) |
ATK_ROLE_TIMER | An object containing a numerical counter which indicates an amount of elapsed time from a start point, or the time remaining until an end point. (Since: 2.12) |
ATK_ROLE_DESCRIPTION_LIST | An object that represents a list of term-value groups. A term-value group represents a individual description and consist of one or more names (ATK_ROLE_DESCRIPTION_TERM) followed by one or more values (ATK_ROLE_DESCRIPTION_VALUE). For each list, there should not be more than one group with the same term name. (Since: 2.12) |
ATK_ROLE_DESCRIPTION_TERM | An object that represents a term or phrase with a corresponding definition. (Since: 2.12) |
ATK_ROLE_DESCRIPTION_VALUE | An object that represents the description, definition or value of a term. (Since: 2.12) |
ATK_ROLE_STATIC | A generic non-container object whose purpose is to display a brief amount of information to the user and whose role is known by the implementor but lacks semantic value for the user. Examples in which `ATK_ROLE_STATIC` is appropriate include the message displayed in a message box and an image used as an alternative means to display text. `ATK_ROLE_STATIC` should not be applied to widgets which are traditionally interactive, objects which display a significant amount of content, or any object which has an accessible relation pointing to another object. Implementors should expose the displayed information through the accessible name of the object. If doing so seems inappropriate, it may indicate that a different role should be used. For labels which describe another widget, see `ATK_ROLE_LABEL`. For text views, see `ATK_ROLE_TEXT`. For generic containers, see `ATK_ROLE_PANEL`. For objects whose role is not known by the implementor, see `ATK_ROLE_UNKNOWN`. (Since: 2.16) |
ATK_ROLE_MATH_FRACTION | An object that represents a mathematical fraction. (Since: 2.16) |
ATK_ROLE_MATH_ROOT | An object that represents a mathematical expression displayed with a radical. (Since: 2.16) |
ATK_ROLE_SUBSCRIPT | An object that contains text that is displayed as a subscript. (Since: 2.16) |
ATK_ROLE_SUPERSCRIPT | An object that contains text that is displayed as a superscript. (Since: 2.16) |
ATK_ROLE_FOOTNOTE | An object that contains the text of a footnote. (Since: 2.26) |
ATK_ROLE_CONTENT_DELETION | Content previously deleted or proposed to be deleted, e.g. in revision history or a content view providing suggestions from reviewers. (Since: 2.34) |
ATK_ROLE_CONTENT_INSERTION | Content previously inserted or proposed to be inserted, e.g. in revision history or a content view providing suggestions from reviewers. (Since: 2.34) |
ATK_ROLE_MARK | A run of content that is marked or highlighted, such as for reference purposes, or to call it out as having a special purpose. If the marked content has an associated section in the document elaborating on the reason for the mark, then `ATK_RELATION_DETAILS` should be used on the mark to point to that associated section. In addition, the reciprocal relation `ATK_RELATION_DETAILS_FOR` should be used on the associated content section to point back to the mark. (Since: 2.36) |
ATK_ROLE_SUGGESTION | A container for content that is called out as a proposed change from the current version of the document, such as by a reviewer of the content. This role should include either `ATK_ROLE_CONTENT_DELETION` and/or `ATK_ROLE_CONTENT_INSERTION` children, in any order, to indicate what the actual change is. (Since: 2.36) |
ATK_ROLE_LAST_DEFINED | not a valid role, used for finding end of the enumeration |

### enum AtkLayer

Describes the layer of a component

These enumerated "layer values" are used when determining which UI rendering layer a component is drawn into, which can help in making determinations of when components occlude one another.

#### Members

ATK_LAYER_INVALID | The object does not have a layer |
ATK_LAYER_BACKGROUND | This layer is reserved for the desktop background |
ATK_LAYER_CANVAS | This layer is used for Canvas components |
ATK_LAYER_WIDGET | This layer is normally used for components |
ATK_LAYER_MDI | This layer is used for layered components |
ATK_LAYER_POPUP | This layer is used for popup components, such as menus |
ATK_LAYER_OVERLAY | This layer is reserved for future use. |
ATK_LAYER_WINDOW | This layer is used for toplevel windows. |

### AtkImplementor

    typedef struct _AtkImplementor AtkImplementor;

### struct AtkAttribute

    struct AtkAttribute {
      gchar* name;
      gchar* value;
    };

AtkAttribute is a string name/value pair representing a generic attribute. This can be used to expose additional information from an accessible object as a whole (see `atk_object_get_attributes()`) or an document (see `atk_document_get_attributes()`). In the case of text attributes (see `atk_text_get_default_attributes()`), AtkTextAttribute enum defines all the possible text attribute names. You can use `atk_text_attribute_get_name()` to get the string name from the enum value. See also `atk_text_attribute_for_name()` and `atk_text_attribute_get_value()` for more information.

A string name/value pair representing a generic attribute.

#### Members

gchar *`name`; | The attribute name. |
gchar *`value`; | the value of the attribute, represented as a string. |

### AtkAttributeSet

    typedef GSList AtkAttributeSet;

This is a singly-linked list (a GSList) of AtkAttribute. It is used by `atk_text_get_run_attributes()`, `atk_text_get_default_attributes()`, `atk_editable_text_set_run_attributes()`, `atk_document_get_attributes()` and `atk_object_get_attributes()`

### AtkPropertyValues

    typedef struct {
      const gchar  *property_name;
      GValue old_value;
      GValue new_value;
    } AtkPropertyValues;

Note: `old_value` field of AtkPropertyValues will not contain a valid value. This is a field defined with the purpose of contain the previous value of the property, but is not used anymore.

#### Members

const gchar *`property_name`; | The name of the ATK property which has changed. |
GValue `old_value`; | NULL. This field is not used anymore. |
GValue `new_value`; | The new value of the named property. |

## Property Details

### The `“accessible-component-layer”` property

      “accessible-component-layer” gint

The accessible layer of this object.

Owner: AtkObject

Flags: Read

Allowed values: >= 0

Default value: 0

### The `“accessible-component-mdi-zorder”` property

      “accessible-component-mdi-zorder” gint

The accessible MDI value of this object.

Owner: AtkObject

Flags: Read

Default value: -2147483648

### The `“accessible-description”` property

      “accessible-description”   gchar *

Description of an object, formatted for assistive technology access.

Owner: AtkObject

Flags: Read / Write

Default value: NULL

### The `“accessible-hypertext-nlinks”` property

      “accessible-hypertext-nlinks” gint

The number of links which the current AtkHypertext has.

Owner: AtkObject

Flags: Read

Allowed values: >= 0

Default value: 0

### The `“accessible-name”` property

      “accessible-name”          gchar *

Object instance’s name formatted for assistive technology access.

Owner: AtkObject

Flags: Read / Write

Default value: NULL

### The `“accessible-parent”` property

      “accessible-parent”        AtkObject *

Parent of the current accessible as returned by atk_object_get_parent().

Owner: AtkObject

Flags: Read / Write

### The `“accessible-role”` property

      “accessible-role”          AtkRole

The accessible role of this object.

Owner: AtkObject

Flags: Read / Write

Default value: ATK_ROLE_UNKNOWN

### The `“accessible-table-caption”` property

      “accessible-table-caption” gchar *

Table caption.

`AtkObject:accessible-table-caption` is deprecated and should not be used in newly-written code.

Since 1.3. Use table-caption-object instead.

Owner: AtkObject

Flags: Read / Write

Default value: NULL

### The `“accessible-table-caption-object”` property

      “accessible-table-caption-object” AtkObject *

Is used to notify that the table caption has changed.

Owner: AtkObject

Flags: Read / Write

### The `“accessible-table-column-description”` property

      “accessible-table-column-description” gchar *

Accessible table column description.

`AtkObject:accessible-table-column-description` is deprecated and should not be used in newly-written code.

Since 2.12. Use `atk_table_get_column_description()` and `atk_table_set_column_description()` instead.

Owner: AtkObject

Flags: Read / Write

Default value: NULL

### The `“accessible-table-column-header”` property

      “accessible-table-column-header” AtkObject *

Accessible table column header.

`AtkObject:accessible-table-column-header` is deprecated and should not be used in newly-written code.

Since 2.12. Use `atk_table_get_column_header()` and `atk_table_set_column_header()` instead.

Owner: AtkObject

Flags: Read / Write

### The `“accessible-table-row-description”` property

      “accessible-table-row-description” gchar *

Accessible table row description.

`AtkObject:accessible-table-row-description` is deprecated and should not be used in newly-written code.

Since 2.12. Use `atk_table_get_row_description()` and `atk_table_set_row_description()` instead.

Owner: AtkObject

Flags: Read / Write

Default value: NULL

### The `“accessible-table-row-header”` property

      “accessible-table-row-header” AtkObject *

Accessible table row header.

`AtkObject:accessible-table-row-header` is deprecated and should not be used in newly-written code.

Since 2.12. Use `atk_table_get_row_header()` and `atk_table_set_row_header()` instead.

Owner: AtkObject

Flags: Read / Write

### The `“accessible-table-summary”` property

      “accessible-table-summary” AtkObject *

Is used to notify that the table summary has changed.

Owner: AtkObject

Flags: Read / Write

### The `“accessible-value”` property

      “accessible-value”         gdouble

Numeric value of this object, in case being and AtkValue.

`AtkObject:accessible-value` is deprecated and should not be used in newly-written code.

Since 2.12. Use `atk_value_get_value_and_text()` to get the value, and value-changed signal to be notified on their value changes.

Owner: AtkObject

Flags: Read / Write

Allowed values: >= 0

Default value: 0

## Signal Details

### The `“active-descendant-changed”` signal

    void
    user_function (AtkObject *atkobject,
                   gpointer   arg1,
                   gpointer   user_data)

The "active-descendant-changed" signal is emitted by an object which has the state ATK_STATE_MANAGES_DESCENDANTS when the focus object in the object changes. For instance, a table will emit the signal when the cell in the table which has focus changes.

#### Parameters

atkobject | the object which received the signal. |
arg1 | the newly focused object. | [type AtkObject]
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“children-changed”` signal

    void
    user_function (AtkObject *atkobject,
                   guint      arg1,
                   gpointer   arg2,
                   gpointer   user_data)

The signal "children-changed" is emitted when a child is added or removed form an object. It supports two details: "add" and "remove"

#### Parameters

atkobject | the object which received the signal. |
arg1 | The index of the added or removed child. The value can be -1. This is used if the value is not known by the implementor when the child is added/removed or irrelevant. |
arg2 | A gpointer to the child AtkObject which was added or removed. If the child was removed, it is possible that it is not available for the implementor. In that case this pointer can be NULL. | [type AtkObject]
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“focus-event”` signal

    void
    user_function (AtkObject *atkobject,
                   gboolean   arg1,
                   gpointer   user_data)

The signal "focus-event" is emitted when an object gained or lost focus.

`AtkObject::focus-event` has been deprecated since version 2.9.4 and should not be used in newly-written code.

Use the “state-change” signal instead.

#### Parameters

atkobject | the object which received the signal |
arg1 | a boolean value which indicates whether the object gained or lost focus. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last

### The `“property-change”` signal

    void
    user_function (AtkObject *atkobject,
                   gpointer   arg1,
                   gpointer   user_data)

The signal "property-change" is emitted when an object's property value changes. `arg1` contains an AtkPropertyValues with the name and the new value of the property whose value has changed. Note that, as with GObject notify, getting this signal does not guarantee that the value of the property has actually changed; it may also be emitted when the setter of the property is called to reinstate the previous value.

Toolkit implementor note: ATK implementors should use `g_object_notify()` to emit property-changed notifications. “property-changed” is needed by the implementation of `atk_add_global_event_listener()` because GObject notify doesn't support emission hooks.

#### Parameters

atkobject | the object which received the signal. |
arg1 | an AtkPropertyValues containing the new value of the property which changed. | [type AtkPropertyValues]
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“state-change”` signal

    void
    user_function (AtkObject *atkobject,
                   gchar     *arg1,
                   gboolean   arg2,
                   gpointer   user_data)

The "state-change" signal is emitted when an object's state changes. The detail value identifies the state type which has changed.

#### Parameters

atkobject | the object which received the signal. |
arg1 | The name of the state which has changed |
arg2 | A boolean which indicates whether the state has been set or unset. |
user_data | user data set when the signal handler was connected. |

Flags: Has Details

### The `“visible-data-changed”` signal

    void
    user_function (AtkObject *atkobject,
                   gpointer   user_data)

The "visible-data-changed" signal is emitted when the visual appearance of the object changed.

#### Parameters

atkobject | the object which received the signal. |
user_data | user data set when the signal handler was connected. |

Flags: Run Last